package com.jpsoft.picc.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_company_invoice的实体类
 */
@Data
@ApiModel(value = "base_company_invoice的实体类")
public class CompanyInvoice {
	/**
	 *ID
	 */
        @ApiModelProperty(value = "ID")
	private String id;
	/**
	 *企业编号
	 */
        @ApiModelProperty(value = "企业编号")
	private String companyId;
	/**
	 *发票类型
	 */
        @ApiModelProperty(value = "发票类型")
	private String type;
	/**
	 *发票抬头
	 */
        @ApiModelProperty(value = "发票抬头")
	private String title;
	/**
	 *税号
	 */
        @ApiModelProperty(value = "税号")
	private String identifier;
	/**
	 *开户银行
	 */
        @ApiModelProperty(value = "开户银行")
	private String bank;
	/**
	 *企业账号
	 */
        @ApiModelProperty(value = "企业账号")
	private String companyAccount;
	/**
	 *联行号
	 */
        @ApiModelProperty(value = "联行号")
	private String bankAccount;
	/**
	 *企业地址
	 */
        @ApiModelProperty(value = "企业地址")
	private String address;
	/**
	 *联系电话
	 */
        @ApiModelProperty(value = "联系电话")
	private String telephone;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
}