package com.jpsoft.picc.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.picc.modules.base.dao.CompanyMemberDAO;
import com.jpsoft.picc.modules.base.entity.CompanyMember;
import com.jpsoft.picc.modules.base.service.CompanyMemberService;
import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="companyMemberService")
public class CompanyMemberServiceImpl implements CompanyMemberService {
	@Resource(name="companyMemberDAO")
	private CompanyMemberDAO companyMemberDAO;

	@Override
	public CompanyMember get(String id) {
		// TODO Auto-generated method stub
		return companyMemberDAO.get(id);
	}

	@Override
	public int insert(CompanyMember model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return companyMemberDAO.insert(model);
	}

	@Override
	public int update(CompanyMember model) {
		// TODO Auto-generated method stub
		return companyMemberDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return companyMemberDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = companyMemberDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<CompanyMember> list() {
		// TODO Auto-generated method stub
		return companyMemberDAO.list();
	}
		
	@Override
	public Page<CompanyMember> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,List<Sort> sortList) {
        Page<CompanyMember> page = PageHelper.startPage(pageNumber,pageSize).doSelectPage(()->{
            companyMemberDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<CompanyMember> findByNotInPolicyMember(String companyId, List<String> excludePolicyList) {
		return companyMemberDAO.findByNotInPolicyMember(companyId,excludePolicyList);
	}
}