package com.jpsoft.picc.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.picc.modules.base.dao.InsuranceAgentDAO;
import com.jpsoft.picc.modules.base.entity.InsuranceAgent;
import com.jpsoft.picc.modules.base.service.InsuranceAgentService;
import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="insuranceAgentService")
public class InsuranceAgentServiceImpl implements InsuranceAgentService {
	@Resource(name="insuranceAgentDAO")
	private InsuranceAgentDAO insuranceAgentDAO;

	@Override
	public InsuranceAgent get(String id) {
		// TODO Auto-generated method stub
		return insuranceAgentDAO.get(id);
	}

	@Override
	public int insert(InsuranceAgent model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return insuranceAgentDAO.insert(model);
	}

	@Override
	public int update(InsuranceAgent model) {
		// TODO Auto-generated method stub
		return insuranceAgentDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return insuranceAgentDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = insuranceAgentDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<InsuranceAgent> list() {
		// TODO Auto-generated method stub
		return insuranceAgentDAO.list();
	}

	@Override
	public List<InsuranceAgent> listByType(String type){
		return insuranceAgentDAO.listByType(type);
	}
		
	@Override
	public Page<InsuranceAgent> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,List<Sort> sortList) {
        Page<InsuranceAgent> page = PageHelper.startPage(pageNumber,pageSize).doSelectPage(()->{
            insuranceAgentDAO.search(searchParams,sortList);
        });
        
        return page;
	}
}