package com.jpsoft.picc.modules.business.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jpsoft.picc.modules.common.constant.PolicyStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 描述:business_insurance_policy_record的实体类
 */
@ApiModel(value = "business_insurance_policy_record的实体类")
public class InsurancePolicyRecord {
    private String id;
    private String policyId;
    private String opinion;
    private String processStatus;
    private Boolean delFlag;
    private String createBy;
    private Date createTime;
    private String updateBy;
    private Date updateTime;
    @ApiModelProperty(value = "状态:待制单50/待出单60/已出单70")
    private String status;
    private String statusN;

    /**
     * 获取编号
     */
    @ApiModelProperty(value = "编号")
    public String getId() {
        return id;
    }

    /**
     * 设置编号
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取每月投保单申请ID
     */
    @ApiModelProperty(value = "每月投保单申请ID")
    public String getPolicyId() {
        return policyId;
    }

    /**
     * 设置每月投保单申请ID
     */
    public void setPolicyId(String policyId) {
        this.policyId = policyId;
    }

    /**
     * 获取意见
     */
    @ApiModelProperty(value = "意见")
    public String getOpinion() {
        return opinion;
    }

    /**
     * 设置意见
     */
    public void setOpinion(String opinion) {
        this.opinion = opinion;
    }

    /**
     * 获取流程审核状态:正常/回退等
     */
    @ApiModelProperty(value = "流程审核状态:正常/回退等")
    public String getProcessStatus() {
        return processStatus;
    }

    /**
     * 设置流程审核状态:正常/回退等
     */
    public void setProcessStatus(String processStatus) {
        this.processStatus = processStatus;
    }

    /**
     * 获取是否删除
     */
    @ApiModelProperty(value = "是否删除")
    public Boolean getDelFlag() {
        return delFlag;
    }

    /**
     * 设置是否删除
     */
    public void setDelFlag(Boolean delFlag) {
        this.delFlag = delFlag;
    }

    /**
     * 获取创建人
     */
    @ApiModelProperty(value = "创建人")
    public String getCreateBy() {
        return createBy;
    }

    /**
     * 设置创建人
     */
    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    /**
     * 获取创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * 设置创建时间
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取修改人
     */
    @ApiModelProperty(value = "修改人")
    public String getUpdateBy() {
        return updateBy;
    }

    /**
     * 设置修改人
     */
    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    /**
     * 获取修改时间
     */
    @ApiModelProperty(value = "修改时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    public Date getUpdateTime() {
        return updateTime;
    }

    /**
     * 设置修改时间
     */
    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    /**
     *获取状态:待制单50/待出单60/已出单70
     */
    public String getStatus(){
        return status;
    }

    /**
     *设置状态:待制单50/待出单60/已出单70
     */
    public void setStatus(String status){
        this.status = status;
    }

    /**
     * 状态翻译
     * @return
     */
    public String getStatusN() {
        String statusN = "";
        if(status.equals("10")){
            statusN = PolicyStatus.Draft.getText();
        }
        else if(status.equals("15")){
            statusN = PolicyStatus.Back.getText();
        }
        else if(status.equals("20")){
            statusN = PolicyStatus.PendingTrial.getText();
        }
        else if(status.equals("30")){
            statusN = PolicyStatus.PendingRetrial.getText();
        }
        else if(status.equals("40")){
            statusN = PolicyStatus.PendingPay.getText();
        }
        else if(status.equals("50")){
            statusN = PolicyStatus.PendingMakePolicy.getText();
        }
        else if(status.equals("60")){
            statusN = PolicyStatus.PendingOutPolicy.getText();
        }
        else if(status.equals("70")){
            statusN = PolicyStatus.SendOutPolicy.getText();
        }
        else{
            statusN = PolicyStatus.Expired.getText();
        }
        return statusN;
    }

    public void setStatusN(String statusN){
        this.statusN = statusN;
    }
}