package com.jpsoft.picc.modules.business.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.jpsoft.picc.modules.business.dao.InsurancePolicyMemberDAO;
import com.jpsoft.picc.modules.business.entity.InsurancePolicyMember;
import com.jpsoft.picc.modules.business.service.InsurancePolicyMemberService;
import com.jpsoft.picc.modules.common.dto.Sort;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Transactional
@Component(value = "insurancePolicyMemberService")
public class InsurancePolicyMemberServiceImpl implements InsurancePolicyMemberService {
    @Resource(name = "insurancePolicyMemberDAO")
    private InsurancePolicyMemberDAO insurancePolicyMemberDAO;

    @Override
    public InsurancePolicyMember get(String id) {
        // TODO Auto-generated method stub
        return insurancePolicyMemberDAO.get(id);
    }

    @Override
    public int insert(InsurancePolicyMember model) {
        // TODO Auto-generated method stub
        //model.setId(UUID.randomUUID().toString());

        return insurancePolicyMemberDAO.insert(model);
    }

    @Override
    public int update(InsurancePolicyMember model) {
        // TODO Auto-generated method stub
        return insurancePolicyMemberDAO.update(model);
    }

    @Override
    public int delete(String id) {
        // TODO Auto-generated method stub
        return insurancePolicyMemberDAO.delete(id);
    }

    @Override
    public boolean exist(String id) {
        // TODO Auto-generated method stub
        int count = insurancePolicyMemberDAO.exist(id);

        return count > 0 ? true : false;
    }

    @Override
    public List<InsurancePolicyMember> list() {
        // TODO Auto-generated method stub
        return insurancePolicyMemberDAO.list();
    }

    @Override
    public Page<InsurancePolicyMember> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize, List<Sort> sortList) {
        Page<InsurancePolicyMember> page = PageHelper.startPage(pageNumber, pageSize).doSelectPage(() -> {
            insurancePolicyMemberDAO.search(searchParams, sortList);
        });

        return page;
    }

    @Override
    public long countByPolicyIdAndJobsId(String policyId, String jobsId) {
        return insurancePolicyMemberDAO.countByPolicyIdAndJobsId(policyId,jobsId);
    }

    @Override
    public List<InsurancePolicyMember> findByPolicyId(String policyId) {
        return insurancePolicyMemberDAO.findByPolicyId(policyId);
    }

    @Override
    public boolean exist(String policyId, String memberId) {
        int count = insurancePolicyMemberDAO.countByPolicyIdAndMemberId(policyId,memberId);

        return count>0;
    }
}