package com.jpsoft.picc.modules.auth.controller;

import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.base.entity.Company;
import com.jpsoft.picc.modules.base.entity.CompanyUser;
import com.jpsoft.picc.modules.base.service.CompanyService;
import com.jpsoft.picc.modules.base.service.CompanyUserService;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.jpsoft.picc.modules.common.utils.PojoUtils;
import com.jpsoft.picc.modules.common.dto.MessageResult;
import com.jpsoft.picc.modules.base.entity.CompanyInvoice;
import com.jpsoft.picc.modules.base.service.CompanyInvoiceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.jasig.cas.client.authentication.AttributePrincipal;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

@RestController
@RequestMapping("/companyInvoice")
@Api(description = "companyInvoice")
public class CompanyInvoiceController {
    private Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private CompanyService companyService;
    @Autowired
    private CompanyUserService companyUserService;
    @Autowired
    private CompanyInvoiceService companyInvoiceService;

    @GetMapping(value="detail")
    @ApiOperation(value = "获取发票信息")
    public MessageResult<CompanyInvoice> detail(HttpServletRequest request){
        MessageResult<CompanyInvoice> messageResult = new MessageResult<>();

        try {
            //todo
            AttributePrincipal principal = (AttributePrincipal) request.getUserPrincipal();
            CompanyUser companyUser = companyUserService.findByUserName(principal.getName());
            CompanyInvoice companyInvoice = companyInvoiceService.getByCompanyId(companyUser.getCompanyId());

            if(companyInvoice == null) {
                companyInvoice = new CompanyInvoice();
            }

            messageResult.setResult(true);
            messageResult.setData(companyInvoice);
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @PostMapping(value="save")
    @ApiOperation(value = "保存发票信息")
    public MessageResult<String> save(CompanyInvoice companyInvoice,HttpServletRequest request){
        MessageResult<String> messageResult = new MessageResult<>();

        try {
            //todo
            AttributePrincipal principal = (AttributePrincipal) request.getUserPrincipal();
            CompanyUser companyUser = companyUserService.findByUserName(principal.getName());

            if(StringUtils.isNotEmpty(companyInvoice.getId())){
                companyInvoice.setUpdateBy(principal.getName());
                companyInvoice.setUpdateTime(new Date());
                companyInvoiceService.update(companyInvoice);
            }else{
                companyInvoice.setCompanyId(companyUser.getCompanyId());
                companyInvoice.setDelFlag(false);
                companyInvoice.setCreateBy(principal.getName());
                companyInvoice.setCreateTime(new Date());
                companyInvoiceService.insert(companyInvoice);
            }

            messageResult.setResult(true);
        }
        catch (Exception ex){
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }
}
