package com.jpsoft.picc.modules.auth.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jpsoft.picc.modules.base.entity.InsuranceDefinitionLimit;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
@ApiModel(value = "参保信息")
public class AcceptInsuranceDTO {
    @ApiModelProperty(value = "险种")
    private String insuranceDefName;

    @ApiModelProperty(value = "险种限额列表")
    private List<InsuranceDefinitionLimit> insuranceDefLimitList;

    @ApiModelProperty(value = "行业/职业类型及收费标准")
    private List<InsuranceJobsDTO> insuranceJobsList;

    @ApiModelProperty(value = "总金额")
    private BigDecimal totalAmount;

    @DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
    @ApiModelProperty(value = "保险起始时间")
    private Date startTime;


    @DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
    @ApiModelProperty(value = "保险结束时间")
    private Date endTime;
}
